package blog;

import java.io.IOException;

/**
 * Interface representing an indexing system.
 */
public interface Indexer {

    /**
     * The field name for the content.
     */
    public static final String CONTENT = "content";

    /**
     * The field name for the document id.
     */
    public static final String DOC_ID = "DOC_ID";

    /**
     * Index a document represented by data
     * @param data the document information
     * @throws IOException for any underlying issues
     */
    public void index(DocumentData data) throws IOException;

}