package blog;

import org.apache.lucene.queryparser.flexible.core.QueryNodeException;

import java.io.IOException;
import java.util.List;

/**
 * An interface representing a query for results.  This class returns all of the results for a given query.
 */
public interface Searcher {
    /**
     * Return a list of hits, by document id, for the given query string.  The query string is assumed to be
     * the same syntax as the underlying search engine.
     * @param q the query string over which to return hits.
     * @return list of document ids returned by the query
     * @throws IOException for underlying system exceptions
     * @throws QueryNodeException for underlying index exceptions
     */
    public List<String> search(String q) throws IOException, QueryNodeException;
}
